=begin
#Faxsuite RESTful API

#<p><img src=\"https://service.fax-api.de/4.0/img/fax-api.png\" height=\"100\" title=\"title\" /></p>  # API Definition <p><img src=\"https://service.fax-api.de/4.0/img/open_api.png\" height=\"50\" title=\"title\" /></p>  Die <b>RESTful API</b> basiert auf den <b>OpenAPI v3.0.3</b> Spezifikationen. OpenAPI Spezifikationen (OAS) definieren eine standardisierte und programmiersprachenunabhängige Schnittstellenbeschreibung für RESTful APIs. Diese Schnittstelle ist nutzbar ohne dass der Zugang zum Quellcode, zusätzliche Dokumentation oder die Untersuchung des Netzwerk-Traffics erforderlich ist. Somit kann ein Nutzer den Dienst mit einem Minimum an Implementierungslogik verstehen, mit ihm interagieren und einfach und schnell als API-Schnittstelle in seine eigene Softwareanwendung integrieren..<br><br>Weitere Informationen zu OpenAPI finden sie hier: <a href=\"https://www.openapis.org/\"><b>https://www.openapis.org/</b></a>   # Einleitung  <p><img src=\"https://service.fax-api.de/4.0/img/fax-api-faxsuite_v2.png\" height=\"350\" title=\"title\" />  </p>  Mit unserer <b>Faxsuite</b> können Sie überall und zu jederzeit Faxe senden und empfangen. Neben vielen anderen Funktionalitäten bietet Ihnen unsere <b>Faxsuite</b> auch eine RESTFul API-Schnittstelle. Damit können Sie z. B. aus Ihrer eigenen Softwareanwendung Faxe automatisiert versenden. Zeitintensive und teure Investionen in Hardware und Software gehören der Vergangenheit an und sind nicht mehr notwendig..<br><br>Um den API Service nutzen zu können, müssen Sie sich für die <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a> anmelden. Ein kostenloser Testzugang kann <a href=\"https://www.faxverteiler.com/testzugang/\"><b>hier</b></a> beantragt werden. (<i>To use the API service you need to sign up for the <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a>. A free trial access can be requested <a href=\"https://www.faxverteiler.com/testzugang/\"><b>here</b></a></i>).<br><br>Mit der <b>Faxsuite</b> haben Sie die Kontrolle über Ihre Fax-Kampangen. Mit dem kostenlosen Testzugang können Sie alle Faxsuite Module (Fax-API, Mail2Fax, Faxdrucker, Faxmailing und Faxempfang) unverbindlich ausprobieren. Sie bekommen 10 kostenlose Faxseiten, die Sie zum aktiven Kennenlernen unserer Faxsuite nutzen können. (<i>You can test the <b>Faxsuite</b> modules for four weeks without obligation. You will receive 10 free fax pages with the free trial access</i>)<br><br>Nachdem Sie den Zugang beantragt haben, können Sie sich <a href=\"https://www.faxsuite.de/\"><b>hier</b></a> in die <b>Faxsuite</b> einloggen. Unter dem Menüpunkt 'FAX-API | Konto verwalten' können Sie ein neues Fax-API Konto erstellen. Bei der Erstellung des Fax-API Kontos wird automatisch ein Autorisierungs-Schlüssel generiert, welchen Sie für den Zugang zur API-Schnittstelle benötigen. (<i>After creating a login you can access the <b>Faxsuite</b> <a href=\"https://www.faxsuite.de/\"><b>here</b></a>. In the menu 'FAX-API | Konto verwalten' you can create a new API-Account and receive the related token/key you need to gain access to our API service</i>).<br><br>Die standardisierte API Dokumentation wird Ihnen in zwei unterschiedlichen, als nicht <b>interaktive</b> und <b>interaktive</b> Varinaten angeboten:  |Name|Type|Link| |-----|-----|-------| | <b>Redoc</b> | non interactive | <b><a href=\"https://service.fax-api.de/4.0/rest/index.html\">click here for redoc</a></b> | <b>Swagger UI</b> | interactive (self hosted) | <b><a href=\"https://service.fax-api.de/4.0/rest/swagger-ui/index.html\">click here for swagger</a></b> |  

OpenAPI spec version: 4.0.0
Contact: support@fax-api.de
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.35
=end

module SwaggerClient
  class JobsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # /jobs
    # Description: Resource to obtain a list of fax jobs
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :object_limit Query parameter to change de default limitation of objects in the result data array (default to 100)
    # @option opts [Integer] :object_offset Query parameter to change de default offset of objects in the result data array (default to 0)
    # @option opts [BOOLEAN] :filter_same_account Query parameter to fetch jobs after the api account linked to the used token/key for authorization (default to false)
    # @option opts [String] :filter_title Query parameter to fetch jobs after his title
    # @option opts [String] :filter_status Query parameter to fetch jobs after his status
    # @option opts [DateTime] :filter_date_from Query parameter to fetch jobs with a later date in TimeToSend. Can be combined with filterDateTo to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like &#x27;2022-01-01T10:00:00+01:00&#x27;. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00)
    # @option opts [DateTime] :filter_date_to Query parameter to fetch jobs with a previous date in TimeToSend. Can be combined with filterDateFrom to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like &#x27;2022-01-01T10:00:00+02:00&#x27;. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00
    # @option opts [DateTime] :filter_date_until_from Query parameter to fetch jobs with a later date in TimeToSendUntil. Can be combined with filterDateUntilTo to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like &#x27;2022-01-01T10:00:00+01:00&#x27;. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00)
    # @option opts [DateTime] :filter_date_until_to Query parameter to fetch jobs with a previous date in TimeToSendUntil. Can be combined with filterDateUIntilFrom to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like &#x27;2022-01-01T10:00:00+02:00&#x27;. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00
    # @option opts [String] :filter_cost_center Query parameter to fetch jobs after his cost center
    # @option opts [String] :sort_field Available sort options for the result data array.
    # @option opts [String] :sort_order Describes the order for used sort fields (default to asc)
    # @return [Jobs]
    def get_jobs(opts = {})
      data, _status_code, _headers = get_jobs_with_http_info(opts)
      data
    end

    # /jobs
    # Description: Resource to obtain a list of fax jobs
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :object_limit Query parameter to change de default limitation of objects in the result data array
    # @option opts [Integer] :object_offset Query parameter to change de default offset of objects in the result data array
    # @option opts [BOOLEAN] :filter_same_account Query parameter to fetch jobs after the api account linked to the used token/key for authorization
    # @option opts [String] :filter_title Query parameter to fetch jobs after his title
    # @option opts [String] :filter_status Query parameter to fetch jobs after his status
    # @option opts [DateTime] :filter_date_from Query parameter to fetch jobs with a later date in TimeToSend. Can be combined with filterDateTo to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like &#x27;2022-01-01T10:00:00+01:00&#x27;. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00)
    # @option opts [DateTime] :filter_date_to Query parameter to fetch jobs with a previous date in TimeToSend. Can be combined with filterDateFrom to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like &#x27;2022-01-01T10:00:00+02:00&#x27;. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00
    # @option opts [DateTime] :filter_date_until_from Query parameter to fetch jobs with a later date in TimeToSendUntil. Can be combined with filterDateUntilTo to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like &#x27;2022-01-01T10:00:00+01:00&#x27;. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00)
    # @option opts [DateTime] :filter_date_until_to Query parameter to fetch jobs with a previous date in TimeToSendUntil. Can be combined with filterDateUIntilFrom to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like &#x27;2022-01-01T10:00:00+02:00&#x27;. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00
    # @option opts [String] :filter_cost_center Query parameter to fetch jobs after his cost center
    # @option opts [String] :sort_field Available sort options for the result data array.
    # @option opts [String] :sort_order Describes the order for used sort fields
    # @return [Array<(Jobs, Integer, Hash)>] Jobs data, response status code and response headers
    def get_jobs_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: JobsApi.get_jobs ...'
      end
      if @api_client.config.client_side_validation && opts[:'filter_status'] && !['scheduling', 'scheduled', 'processing', 'halted', 'locked', 'canceled', 'finished', 'error'].include?(opts[:'filter_status'])
        fail ArgumentError, 'invalid value for "filter_status", must be one of scheduling, scheduled, processing, halted, locked, canceled, finished, error'
      end
      if @api_client.config.client_side_validation && opts[:'sort_field'] && !['jobId', 'title', 'createTime', 'timeToSend', 'timeToSendUntil'].include?(opts[:'sort_field'])
        fail ArgumentError, 'invalid value for "sort_field", must be one of jobId, title, createTime, timeToSend, timeToSendUntil'
      end
      if @api_client.config.client_side_validation && opts[:'sort_order'] && !['asc', 'desc'].include?(opts[:'sort_order'])
        fail ArgumentError, 'invalid value for "sort_order", must be one of asc, desc'
      end
      # resource path
      local_var_path = '/jobs'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'objectLimit'] = opts[:'object_limit'] if !opts[:'object_limit'].nil?
      query_params[:'objectOffset'] = opts[:'object_offset'] if !opts[:'object_offset'].nil?
      query_params[:'filterSameAccount'] = opts[:'filter_same_account'] if !opts[:'filter_same_account'].nil?
      query_params[:'filterTitle'] = opts[:'filter_title'] if !opts[:'filter_title'].nil?
      query_params[:'filterStatus'] = opts[:'filter_status'] if !opts[:'filter_status'].nil?
      query_params[:'filterDateFrom'] = opts[:'filter_date_from'] if !opts[:'filter_date_from'].nil?
      query_params[:'filterDateTo'] = opts[:'filter_date_to'] if !opts[:'filter_date_to'].nil?
      query_params[:'filterDateUntilFrom'] = opts[:'filter_date_until_from'] if !opts[:'filter_date_until_from'].nil?
      query_params[:'filterDateUntilTo'] = opts[:'filter_date_until_to'] if !opts[:'filter_date_until_to'].nil?
      query_params[:'filterCostCenter'] = opts[:'filter_cost_center'] if !opts[:'filter_cost_center'].nil?
      query_params[:'sortField'] = opts[:'sort_field'] if !opts[:'sort_field'].nil?
      query_params[:'sortOrder'] = opts[:'sort_order'] if !opts[:'sort_order'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Jobs' 

      auth_names = opts[:auth_names] || ['ApiAuthKey']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: JobsApi#get_jobs\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /jobs
    # Description: Resource to create a new fax job
    # @param body Describes the required request body to create a new fax job
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse201]
    def post_job(body, opts = {})
      data, _status_code, _headers = post_job_with_http_info(body, opts)
      data
    end

    # /jobs
    # Description: Resource to create a new fax job
    # @param body Describes the required request body to create a new fax job
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse201, Integer, Hash)>] InlineResponse201 data, response status code and response headers
    def post_job_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: JobsApi.post_job ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling JobsApi.post_job"
      end
      # resource path
      local_var_path = '/jobs'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(body) 

      return_type = opts[:return_type] || 'InlineResponse201' 

      auth_names = opts[:auth_names] || ['ApiAuthKey']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: JobsApi#post_job\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
